Use DES_set_key_unchecked().
[heimdal.git] / lib / hx509 / test_nist2.in
blob09390164c33c31a3666611650d0292fe1289df58
1 #!/bin/sh
3 # Copyright (c) 2004 - 2008 Kungliga Tekniska Högskolan
4 # (Royal Institute of Technology, Stockholm, Sweden).
5 # All rights reserved.
7 # Redistribution and use in source and binary forms, with or without
8 # modification, are permitted provided that the following conditions
9 # are met:
11 # 1. Redistributions of source code must retain the above copyright
12 # notice, this list of conditions and the following disclaimer.
14 # 2. Redistributions in binary form must reproduce the above copyright
15 # notice, this list of conditions and the following disclaimer in the
16 # documentation and/or other materials provided with the distribution.
18 # 3. Neither the name of the Institute nor the names of its contributors
19 # may be used to endorse or promote products derived from this software
20 # without specific prior written permission.
22 # THIS SOFTWARE IS PROVIDED BY THE INSTITUTE AND CONTRIBUTORS ``AS IS'' AND
23 # ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
24 # IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
25 # ARE DISCLAIMED. IN NO EVENT SHALL THE INSTITUTE OR CONTRIBUTORS BE LIABLE
26 # FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
27 # DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
28 # OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
29 # HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
30 # LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
31 # OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
32 # SUCH DAMAGE.
34 # $Id: test_nist.in 21787 2007-08-02 08:50:24Z lha $
37 srcdir="@srcdir@"
38 objdir="@objdir@"
39 nistdir=${objdir}/PKITS_data
40 nistzip=${srcdir}/data/PKITS_data.zip
42 limit="${1:-nolimit}"
44 stat="--statistic-file=${objdir}/statfile"
46 hxtool="${TESTS_ENVIRONMENT} ./hxtool ${stat}"
48 # nistzip is not distributed part of the distribution
49 test -f "$nistzip" || exit 77
51 if ${hxtool} info | grep 'rsa: hcrypto null RSA' > /dev/null ; then
52 exit 77
54 if ${hxtool} info | grep 'rand: not available' > /dev/null ; then
55 exit 77
58 #--------- Try to find unzip
60 oldifs=$IFS
61 IFS=:
62 set -- $PATH
63 IFS=$oldifs
64 found=
66 for p in "$@" ; do
67 test -x "$p/unzip" && { found=1 ; break; }
68 done
69 test "X$found" = "X" && exit 77
71 #---------
74 echo "nist tests, version 2"
76 if [ ! -d "$nistdir" ] ; then
77 ( mkdir "$nistdir" && unzip -d "${nistdir}" "${nistzip}" ) >/dev/null || \
78 { rm -rf "$nistdir" ; exit 1; }
81 ec=
82 name=
83 description=
84 while read result cert other ; do
85 if expr "$result" : "#" > /dev/null; then
86 name=${cert}
87 description="${other}"
88 continue
91 test nolimit != "${limit}" && ! expr "$name" : "$limit" > /dev/null && continue
93 test "$result" = "end" && break
95 args=
96 args="$args cert:FILE:$nistdir/certs/$cert"
97 args="$args chain:DIR:$nistdir/certs"
98 args="$args anchor:FILE:$nistdir/certs/TrustAnchorRootCertificate.crt"
99 # args="$args crl:FILE:$nistdir/crls/TrustAnchorRootCRL.crl"
101 for a in $nistdir/crls/*.crl; do
102 args="$args crl:FILE:$a"
103 done
105 cmd="${hxtool} verify $args"
106 eval ${cmd} > /dev/null
107 res=$?
109 case "${result},${res}" in
110 0,0) r="PASSs";;
111 0,*) r="FAILs";;
112 [123],0) r="FAILf";;
113 [123],*) r="PASSf";;
114 *) echo="unknown result ${result},${res}" ; exit 1 ;;
115 esac
116 if grep "${name} FAIL" $srcdir/data/nist-result2 > /dev/null; then
117 if expr "$r" : "PASS" >/dev/null; then
118 echo "${name} passed when expected not to"
119 echo "# ${description}" > nist2-passed-${name}.tmp
120 ec=1
122 elif expr "$r" : "FAIL.*" >/dev/null ; then
123 echo "$r ${name} ${description}"
124 echo "# ${description}" > nist2-failed-${name}.tmp
125 echo "$cmd" >> nist2-failed-${name}.tmp
126 ec=1
129 done < $srcdir/data/nist-data2
132 echo "done!"
134 exit $ec